(require 'benchmark)

(defun utf-2000-benchmark (count string codesys)
  (let ((forms `(inline
		  (erase-buffer)
		  (insert ,string)
		  (encode-coding-region (point-min) (point-max) ,codesys))))
    (with-temp-buffer
      (benchmark count forms))))

;; length 163
(setq utf-2000-benchmark-string-japanese-jisx0208
      "$B!&!"!#!$!%!'!(!)!*!+!,!-!.!/!0!1!2!3!4!5!6!7!8!9!:!;!<!=!>!?!@!A!B!C!D!E(B
$B!F!G!H!I!J!K!L!M!N!O!P!Q!R!S!T!U!V!W!X!Y!Z![!\!]!^!_!`!a!b!c!d!e!f!g!h!i(B
$B!j!k!l!m!n!o!p!q!r!s!t!u!v!w!x!y!z!{!|!}!~"!"""#"$"%"&"'"(")"*"+","-".(B
$B#A#B#C#D#E#F#G#H#I#J#K#L#M#N#O#P#Q#R#S#T#U#V#W#X#Y#Z(B
$B#a#b#c#d#e#f#g#h#i#j#k#l#m#n#o#p#q#r#s#t#u#v#w#x#y#z(B")

;; length 167
(setq utf-2000-benchmark-string-korean-ksc5601
      "$(C"!"""#"$"%"&"'"(")"*"+","-"."/"0"1"2"3"4"5"6"7"8"9":";"<"=">"?"@"A"B(B
$(C"C"D"E"F"G"H"I"J"K"L"M"N"O"P"Q"R"S"T"U"V"W"X"Y"Z"["\"]"^"_"`"a"b"c"d"e(B
$(C#!#"###$#%#&#'#(#)#*#+#,#-#.#/#0#1#2#3#4#5#6#7#8#9#:#;#<#=#>#?(B
$(C#@#A#B#C#D#E#F#G#H#I#J#K#L#M#N#O#P#Q#R#S#T#U#V#W#X#Y#Z(B
$(C#[#\#]#^#_#`#a#b#c#d#e#f#g#h#i#j#k#l#m#n#o#p#q#r#s#t#u#v#w#x#y#z#{#|#}#~(B")

;; length 1097
(setq utf-2000-benchmark-string-hello (save-window-excursion
				   (view-hello-file)
				   (prog1
				       (buffer-string)
				     (kill-buffer (current-buffer)))))

;;(utf-2000-benchmark 100000 utf-2000-benchmark-string-japanese-jisx0208
;;		    'iso-2022-jp)
;;(utf-2000-benchmark 100000 utf-2000-benchmark-string-japanese-jisx0208
;;		    'utf-8)

;;(utf-2000-benchmark 100000 utf-2000-benchmark-string-korean-ksc5601
;;		    'iso-2022-jp-2)
;;(utf-2000-benchmark 100000 utf-2000-benchmark-string-korean-ksc5601
;;		    'utf-8)

;;(utf-2000-benchmark 100000 utf-2000-benchmark-string-hello
;;		    'iso-2022-jp-2)
;;(utf-2000-benchmark 100000 utf-2000-benchmark-string-hello
;;		    'utf-8)
